<?php
/**
* @copyright    Copyright (C) 2014 Interamind Ltd. All rights reserved.
* @license      GNU/GPL, see LICENSE.txt
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );
jimport('joomla.utilities.date');
require_once JPATH_SITE.DS.'components'.DS.'com_remarkety'.DS.'remarketyLogger.php';

class remarketyModelRemarkety extends Jmodel
{
	var $vmModels = array();
	var $vendor = null;
	var $real_time_zone = null;
	var $base_url;
	var $base;
	
	function __construct(){
		JModel::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_virtuemart' . DS . 'models');
		JTable::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_virtuemart/tables');
		$this->real_time_zone = date_default_timezone_get();
		
		$forceDebug = urldecode(JRequest::getVar( 'debug', '0' ));
		if($forceDebug == 1){
			remarketyLogger::forceDebug();
		}
		
		parent::__construct();
	}
	
	public function getShoppers($limit, $page, $since_id, $updated_at_min){
		$shopper_id_list = $this->getShopperIdList($limit, $page, $since_id, $updated_at_min);
		
		if(is_array($shopper_id_list)){
			$result_shoppers = array();
			foreach ($shopper_id_list as $shopper) {
				$result_shoppers[$shopper->id] = $this->getShopperById($shopper->id, $shopper->name, $shopper->email);
			}
			return $result_shoppers;
		}else{
			return null;
		}		
	}
	
	private function getShopperIdList($limit, $page, $since_id, $updated_at_min){
//		$where = " address_type='BT' ";
		$where = "";
		
		if($since_id != null){
			$where = "u.id > ".$since_id;
		}
		
		if($updated_at_min != null){
			$where .= " AND modified_on > '".$updated_at_min."'";
		}
		
		if(!empty($where)){
			$where = ' WHERE '.$where;
		}
		
		$selecct = " DISTINCT u.id, u.name, u.email, u.registerDate"; 
		$from = ' FROM #__users u LEFT JOIN #__virtuemart_userinfos us ON u.id=us.virtuemart_user_id  ';
		
		$ordering = ' order by u.id ASC';

		$data = $this->exeQuery($selecct, $from, $where, '', $ordering, $limit, $page);

		return $data ;
	}
	

	private function getShopperById($user_id, $name, $email){
		$vmUserModel = $this->getVmModels('user');
		$vmUserModel->_id = $user_id;
		$user = array();
		$user['virtuemart_user_id'] = $user_id;
		
		$juser = JFactory::getUser((int)$user_id);
		$registerDate = $juser->get('registerDate');
		$user['createdOn'] = (string)$registerDate;
		$shopperGroups = $this->getShooperGroups($user_id);
		$user['shopper_groups'] = !empty($shopperGroups) ? $shopperGroups : '';
		$virtuemart_userinfo_id_BT = $vmUserModel->getBTuserinfo_id();
		if(!empty($virtuemart_userinfo_id_BT)){
			$userFieldsArrayBT = $vmUserModel->getUserInfoInUserFields('','BT',$virtuemart_userinfo_id_BT,false);
			$userFieldsBT = $userFieldsArrayBT[$virtuemart_userinfo_id_BT];
			ob_start();
			var_dump($userFieldsBT);
			$var = ob_get_clean();
			remarketyLogger::log('*** Shopper-BT: ' . $var, remarketyLogger::LEVEL_DEBUG);
			
			foreach ($userFieldsBT['fields'] as $userField) {
				if ($userField['type'] != 'delimiter' && $userField['type'] != 'hidden' ){
					if($userField['name'] == "first_name" ||
							$userField['name'] == "last_name" ||
							$userField['name'] == "zip" ||
							$userField['name'] == "email" ||
							$userField['name'] == "virtuemart_country_id" ){
						
						$value = empty($userField['value']) ? '' : $userField['value'];
						$user[$userField['name']] = $value;
					}
				}
			}
			$_data = $vmUserModel->getTable('vmusers');
			$current_user = $_data->load((int)$user_id);
			ob_start();
			var_dump($current_user);
			$var = ob_get_clean();
			remarketyLogger::log('*** Shopper: ' . $var, remarketyLogger::LEVEL_DEBUG);
			$user['modifiedOn'] = (string)$current_user->modified_on;
		}else{
			$pieces = explode(" ", $name);
			$user['first_name'] = $pieces[0];
			$user['last_name'] = isset($pieces[1]) ? $pieces[1] : '';
			$user['email'] = $email;
			$user['modifiedOn'] = (string)$registerDate;
			$user['zip'] = '';
			$user['virtuemart_country_id'] = '';
		}
		
		return $user;
	}

	/**
	 * 
	 * @param $limit
	 * @param $page
	 * @param $since_id
	 * @param $created_at_min
	 * @param $created_at_max
	 * @param $updated_at_min
	 * @param $updated_at_max
	 * @param $order_status
	 * @param $order_id
	 */
	 
	public function getOrders($limit, $page, $since_id, $created_at_min, $created_at_max, $updated_at_min, $updated_at_max, $order_status, $order_id){
		
		$order_id_list = $this->getOrderIdList($limit, $page, $since_id, $created_at_min, $created_at_max, $updated_at_min, $updated_at_max, $order_status, $order_id);
		
		if(is_array($order_id_list)){
			$result_orders = array();
			foreach ($order_id_list as $order) {
				$result_orders[$order->virtuemart_order_id] = $this->getOrderByOrderId($order->virtuemart_order_id);
			}
			return $result_orders;
		}else{
			return null;
		}		
	}
	
	private function getOrderIdList($limit, $page, $since_id, $created_at_min, $created_at_max, $updated_at_min, $updated_at_max, $order_status, $order_id)
	{
		$where = "";
		
		if($since_id != null){
			$where .= " order_id > ".$since_id;
		}
		
		if($created_at_min != null){
			$created_at_min_where = " created_on > '".$created_at_min."'";
			if(!empty($where)){
				$created_at_min_where = " AND ".$created_at_min_where;
			} 
			$where .= $created_at_min_where;
		}
		
		if($created_at_max != null){
			$created_at_max_where = " created_on < '".$created_at_max."'";
			if(!empty($where)){
				$created_at_max_where = " AND ".$created_at_max_where;
			} 
			$where .= $created_at_max_where;
		}
		
		if($updated_at_min != null){
			$updated_at_min_where = " modified_on > '".$updated_at_min."'";
			if(!empty($where)){
				$updated_at_min_where = " AND ".$updated_at_min_where;
			} 
			$where .= $updated_at_min_where;
		}
		
		if($updated_at_max != null){
			$updated_at_max_where = " modified_on < '".$updated_at_max."'";
			if(!empty($where)){
				$updated_at_max_where = " AND ".$updated_at_max_where;
			} 
			$where .= $updated_at_max_where;
		}
		
		if($order_status != null){
			if(!is_array($order_status)){
				$order_status_arr = explode(',', $order_status);
			}
			foreach ($order_status_arr as &$status){
				$status = "'" . $status . "'";
			}
			$status_list_sql = implode(',', $order_status_arr);
			$order_status_where = sprintf(" order_status IN (%s)", $status_list_sql);
			if(!empty($where)){
				$order_status_where = " AND ".$order_status_where;
			} 
			$where .= $order_status_where;
		}
		
		if($order_id != null and is_numeric($order_id)){
			$order_id_where = " order_id=".$order_id;
			if(!empty($where)){
				$order_id_where = " AND ".$order_id_where;
			} 
			$where .= $order_id_where;
		}
		
		if(!empty($where)){
			$where = ' WHERE '.$where;
		}
		
		$selecct = " virtuemart_order_id "; 
		$from = ' FROM #__virtuemart_orders ';
		
		$ordering = ' order by modified_on ASC';

		$data = $this->exeQuery($selecct, $from, $where, '', $ordering, $limit, $page);

		return $data ;
	}
	
	public function getProducts($limit, $page, $since_id, $handle, $vendor, $product_type, $collection_id, 
        		$created_at_min, $created_at_max, $updated_at_min, $updated_at_max, $published_status, $product_id){
        			
		$product_id_list = $this->getProductIdList($limit, $page, $since_id, $handle, $vendor, $product_type, $collection_id, 
        		$created_at_min, $created_at_max, $updated_at_min, $updated_at_max, $published_status, $product_id);
		
		if(is_array($product_id_list)){
			$result_products = array();
			foreach ($product_id_list as $productId) {
				$product = $this->getProductById($productId->virtuemart_product_id);
				
				$result_products[$productId->virtuemart_product_id] = $product;
			}
			return $result_products;
		}else{
			return null;
		}			
	}

	public function getShopSettings(){
		$vendor = $this->getVendor();
		$shop = array();
		$config		= JFactory::getConfig();
		$tzoffset	= $config->getValue('config.offset');

		$shop['name'] = $vendor->vendor_store_name;
		$shop['phone'] = $vendor->vendor_phone;
		$shop['created_at'] = $vendor->created_on;
		$shop['domain'] = $vendor->vendor_url;
		$shop['shop_owner'] = $vendor->vendor_name;
		
		$imagesArr = $vendor->images;
		if($imagesArr != null && is_array($imagesArr) && count($imagesArr) > 0){
			$base_url = $this->getBaseUrl();
			$shop['logoPath'] = $base_url.$imagesArr[0]->file_url;
		}
		
		$currencyModel =  $this->getVmModels('currency');
		$currency = $currencyModel->getCurrency($vendor->vendor_currency);
		
		$shop['currency'] = $currency->currency_code_3;
		
		$shop['money_with_currency_format'] = $currency->currency_positive_style;
		$shop['money_format'] = $currency->currency_positive_style;
		$shop['timezone'] = $tzoffset;
		
		$userModel = $this->getVmModels('user');
		$userId = VirtueMartModelVendor::getUserIdByVendorId(1);
		$userModel->_id = $userId;
				
		$virtuemart_userinfo_id_BT = $userModel->getBTuserinfo_id();
		$userFieldsArray = $userModel->getUserInfoInUserFields('', 'BT', $virtuemart_userinfo_id_BT, false);
		$userFieldsBT = $userFieldsArray[$virtuemart_userinfo_id_BT];
		
		$shop['address'] = $userFieldsBT['fields']['address_1']['value'];
		$shop['city'] = $userFieldsBT['fields']['city']['value'];
		$shop['zip'] = $userFieldsBT['fields']['zip']['value'];
		$shop['country'] = $userFieldsBT['fields']['virtuemart_country_id']['value'];
		$shop['email'] = $userFieldsBT['fields']['email']['value'];
		$shop['province'] = $userFieldsBT['fields']['virtuemart_country_id']['value'];
		
		return $shop;
		
	}
	
	public function getShoppersCount(){
    	$db = JFactory::getDBO();
		$q = 'SELECT COUNT(1) FROM #__users'; 
		$db->setQuery($q);
		$count = $db->loadResult();
		return $count;
	}
	
	public function getOrdersCount(){
		$db = JFactory::getDBO();
		$q = 'SELECT COUNT(1) FROM `#__virtuemart_orders`'; 
		$db->setQuery($q);
		$count = $db->loadResult();
		return $count;
	}
	
	public function getProductsCount(){
		$db = JFactory::getDBO();
		$q = 'SELECT COUNT(1) FROM `#__virtuemart_products`'; 
		$db->setQuery($q);
		$count = $db->loadResult();
		return $count;
	}
	
	/**
	 * 
	 * @param $limit
	 * @param $page
	 * @param $since_id
	 * @param $handle
	 * @param $vendor
	 * @param $product_type
	 * @param $collection_id
	 * @param $created_at_min
	 * @param $created_at_max
	 * @param $updated_at_min
	 * @param $updated_at_max
	 * @param $published_at_min
	 * @param $published_at_max
	 * @param $published_status
	 */
	private function getProductIdList($limit, $page, $since_id, $handle, $vendor, $product_type, $collection_id, 
        		$created_at_min, $created_at_max, $updated_at_min, $updated_at_max, $published_status, $product_id){
		$where = "";
		
		if($since_id != null){
			$where .= " virtuemart_product_id > ".$since_id;
		}
		
		if($vendor != null){
			$vendor_where = " virtuemart_vendor_id = '".$vendor."'";
			if(!empty($where)){
				$vendor_where = " AND ".$vendor_where;
			} 
			$where .= $vendor_where;
		}
		
        if($created_at_min != null){
			$created_at_min_where = " created_on > '".$created_at_min."'";
			if(!empty($where)){
				$created_at_min_where = " AND ".$created_at_min_where;
			} 
			$where .= $created_at_min_where;
		}
		
		if($created_at_max != null){
			$created_at_max_where = " created_on < '".$created_at_max."'";
			if(!empty($where)){
				$created_at_max_where = " AND ".$created_at_max_where;
			} 
			$where .= $created_at_max_where;
		}
		
		if($updated_at_min != null){
			$updated_at_min_where = " modified_on > '".$updated_at_min."'";
			if(!empty($where)){
				$updated_at_min_where = " AND ".$updated_at_min_where;
			} 
			$where .= $updated_at_min_where;
		}
		
		if($updated_at_max != null){
			$updated_at_max_where = " modified_on < '".$updated_at_max."'";
			if(!empty($where)){
				$updated_at_max_where = " AND ".$updated_at_max_where;
			} 
			$where .= $updated_at_max_where;
		}
		
		if($published_status != null){
			$published_status_where = " published  '".$published_status."'";
			if(!empty($where)){
				$published_status_where = " AND ".$published_status_where;
			} 
			$where .= $published_status_where;
		}
		
		
		
		if($product_id != null){
			$product_id_where = " virtuemart_product_id=".$product_id;
			if(!empty($where)){
				$product_id_where = " AND ".$product_id_where;
			} 
			$where .= $product_id_where;
		}
		
		if(!empty($where)){
			$where = ' WHERE '.$where;
		}
		
		$selecct = " virtuemart_product_id "; 
		$from = ' FROM #__virtuemart_products ';
		
		$ordering = ' order by modified_on ASC';

		$data = $this->exeQuery($selecct, $from, $where, '', $ordering, $limit, $page);

		return $data ;
		
	}
	
	private function getProductById($product_id){
		$product = null;
		$productModel = $this->getVmModels('product');
		$product = $productModel->getProductSingle($product_id);
		$productModel->addImages($product, $product_id);
		
		$base_url = $this->getBaseUrl();
		$thumb = $product->images[0]->file_url_thumb;
		$thumb = empty($thumb) ? $product->images[0]->file_url : $product->images[0]->file_url_thumb;
		
		remarketyLogger::log('getProductById thumb 1='.$thumb, remarketyLogger::LEVEL_DEBUG);

		if($thumb == null || $thumb == ''){
			remarketyLogger::log('getProductById thumb 2='.$thumb, remarketyLogger::LEVEL_DEBUG);
			if($product->product_parent_id != 0){
				$parent_product = $productModel->getProductSingle($product->product_parent_id);
				$productModel->addImages($parent_product, $product->product_parent_id);
				if($parent_product->images[0]->file_url_thumb != null){
					$product->productThumbPath = $parent_product->images[0]->file_url_thumb;
					remarketyLogger::log('getProductById thumb 3='.$product->productThumbPath, remarketyLogger::LEVEL_DEBUG);
				}
			}
		}else{
			$product->productThumbPath = $thumb;
			remarketyLogger::log('getProductById thumb 4='.$thumb, remarketyLogger::LEVEL_DEBUG);
		}
		
		if (substr($product->productThumbPath,0,4) != 'http'){
			if (substr($product->productThumbPath,0,4) != 'www.'){
				$product->productThumbPath = $base_url.$thumb;	
				remarketyLogger::log('getProductById thumb 5='.$product->productThumbPath, remarketyLogger::LEVEL_DEBUG);
			}else{
				$product->productThumbPath = "http://".$thumb;
				remarketyLogger::log('getProductById thumb 6='.$product->productThumbPath, remarketyLogger::LEVEL_DEBUG);
			}
		}
		
		$categoriesArr = $product->categories;
		
		$price = null;
		$cost = null;
		$productForPrices = $product;
		if($product->product_parent_id != 0){
			$productForPrices = $productModel->getProductSingle($product->product_parent_id);
		}
		
		if(isset($product->product_price)){
			$price = $product->product_price;
		}else if(isset($productForPrices->prices) && is_array($productForPrices->prices) ){
			if(array_key_exists('costPrice', $productForPrices->prices)){
				$price = $productForPrices->prices['salesPrice'];
				$cost = $productForPrices->prices['cost'];
			}else if(is_array($productForPrices->prices[0]) && array_key_exists('product_price', $productForPrices->prices[0]) ){
				$price = $productForPrices->prices[0]['product_price'];
			}
		}
		
		$result = new stdClass();
		$result->virtuemart_product_id = $product->virtuemart_product_id;
        if(isset($product->product_parent_id) && !empty($product->product_parent_id)){
            $result->parent_product_id = $product->product_parent_id;
        }
		$result->product_sku = $product->product_sku;
		$result->product_name = $product->product_name;
		$result->productThumbPath = $product->productThumbPath;
		$result->modified_on = $product->modified_on;
		$result->price = $price;
		$result->cost = $cost;
		$result->categories = array();
		
		if(!empty($categoriesArr)){
			$catNameArr = $this->getCategoryNames($categoriesArr);
			$result->categories = $catNameArr;
		}
		
		$prod_url = $this->getBase().JRoute::_ ('index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id=' . $product->virtuemart_product_id . '&virtuemart_category_id=' . $product->virtuemart_category_id , false, 0);
		$result->prod_url = $prod_url;
		
		return $result;
	}
	
	private function getBase(){
		if($this->base == null){
			$uri = JURI::getInstance();
			$this->base = $uri->toString(array('scheme', 'user', 'pass', 'host', 'port'));
		}
		return $this->base;
	}
	
	private function getCategoryNames($categoriesArr){
		
		foreach ($categoriesArr as &$category){
			$category = "'" . $category . "'";
		}
		$categories = implode(',', $categoriesArr);
		
		$db = JFactory::getDBO();
		// Get the order details
		$q = 'SELECT category_name	FROM #__virtuemart_categories_'.VMLANG.' 
			WHERE virtuemart_category_id IN('.$categories.')';
		
		$db->setQuery($q);
		$category_rows = $db->loadAssocList();
		$catNameArr = array();
		
		if(!empty($category_rows)){
			foreach ($category_rows as $tmpNameArr) {
				$name = $tmpNameArr['category_name'];
				$catNameArr[] = $name;
			}
		}
		
		return $catNameArr;
	}
	
	public function exeQuery($select, $joinedTables, $whereString = '', $groupBy = '', $orderBy = '', $limit, $page){
		
		remarketyLogger::log('*** exeQuery ', remarketyLogger::LEVEL_DEBUG);
		$orderModel = $this->getVmModels('orders');
		$orderModel->_withCount = true;
		$orderModel->_limit = $limit;
		$limitStart = 0;
		
		if($page > 0){
			$limitStart = ($page * $limit);// + 1;
		}
		
		$orderModel->_limitStart = $limitStart;
		
		//and the where conditions
		$joinedTables .= $whereString .$groupBy .$orderBy;

		$q = 'SELECT SQL_CALC_FOUND_ROWS '.$select.$joinedTables;

		remarketyLogger::log('*** exeQuery select: '.$q, remarketyLogger::LEVEL_DEBUG);
		
		$orderModel->_db->setQuery($q, $limitStart, $limit);

		$orderModel->ids = $orderModel->_db->loadObjectList();

		if(empty($orderModel->ids)){
			$errors = $orderModel->_db->getErrorMsg();
			if( !empty( $errors)){
				vmdebug('exeQuery error in class '.get_class($orderModel).' sql:',$orderModel->_db->getErrorMsg());
			}
		}
		return $orderModel->ids;

	}
	
	//The order is an array of arrays [details[BT], history[], items[]]
	private function getOrderByOrderNumber($orderNumber){
			$orderModel = $this->getVmModels('orders');
			$virtuemart_order_id = $orderModel->getOrderIdByOrderNumber($orderNumber);
			$order = $this->getOrderByOrderId($virtuemart_order_id);
		
		return $order;
	}
	
	private function getOrderByOrderId($virtuemart_order_id){
		
		$order = array('items'=>array(), 'details'=>array(), 'history'=>array());
		$db = JFactory::getDBO();
		$order = array();
		
		// Get the order details
		$q = "SELECT  o.order_total, o.coupon_discount, o.order_discount, o.order_number, o.order_total, o.order_shipment, 
			o.order_shipment_tax, o.virtuemart_user_id, o.coupon_code, o.created_on, o.modified_on, o.order_status, 
			o.order_currency, o.user_currency_id, 
			u.email, u.virtuemart_country_id, u.zip, u.first_name, u.last_name, u.modified_on as umo, u.created_on as uco,
			s.order_status_name, cu.country_name
			FROM #__virtuemart_orders o LEFT JOIN #__virtuemart_orderstates s ON s.order_status_code = o.order_status
			LEFT JOIN #__virtuemart_order_userinfos u ON u.virtuemart_order_id = o.virtuemart_order_id
			LEFT JOIN #__virtuemart_countries cu on u.virtuemart_country_id = cu.virtuemart_country_id
			WHERE o.virtuemart_order_id=".$virtuemart_order_id . " AND u.address_type = 'BT'";
		remarketyLogger::log('*** getOrder, sql= ' . $q , remarketyLogger::LEVEL_DEBUG);
		$db->setQuery($q);
		$order_row = $db->loadObject();
		ob_start();
		var_dump($order_row);
		$orderDump = ob_get_clean();
		remarketyLogger::log('order dump: ' . $orderDump , remarketyLogger::LEVEL_DEBUG);
		$order['created_on'] = $order_row->created_on;
		$order['modified_on'] = $order_row->modified_on;
		
		$currencyModel = $this->getVmModels('currency');
		$currency = $currencyModel->getCurrency($order_row->order_currency);
		$order['currency_code_3'] = $currency->currency_code_3;
		$order['currency_name'] = $currency->currency_name;
		$order['currency_symbol'] = $currency->currency_symbol;
		$order['virtuemart_order_id'] = $virtuemart_order_id;
		$order['order_number'] = $order_row->order_number;
		
		$order['order_total'] = $order_row->order_total;
		$order['orderShipping'] = $order_row->order_shipment + $order_row->order_shipment_tax;
		$order['coupon_discount'] = $order_row->coupon_discount;
		$order['order_discount'] = $order_row->order_discount;
		$order['coupon_code'] = $order_row->coupon_code;
		
		$order['status_code'] = $order_row->order_status;
		
		$order['details']['BT']->virtuemart_user_id = $order_row->virtuemart_user_id;
		$order['details']['BT']->virtuemart_country_id = $order_row->country_name;
		$order['details']['BT']->zip = $order_row->zip;
		$order['details']['BT']->email = $order_row->email;
		$order['details']['BT']->first_name = $order_row->first_name;
		$order['details']['BT']->last_name = $order_row->last_name;
		$order['details']['BT']->created_on = $order_row->uco;
		$order['details']['BT']->modified_on = $order_row->umo;
		
		// Get the order items
		$q = 'SELECT virtuemart_order_item_id, product_quantity, order_item_name, order_item_sku, i.virtuemart_product_id, product_item_price,
		    product_final_price, product_attribute, order_status, virtuemart_category_id 
		   	FROM (#__virtuemart_order_items i LEFT JOIN #__virtuemart_products p ON p.virtuemart_product_id = i.virtuemart_product_id)
			LEFT JOIN #__virtuemart_product_categories c ON p.virtuemart_product_id = c.virtuemart_product_id
			WHERE `virtuemart_order_id`="'.$virtuemart_order_id.'" group by `virtuemart_order_item_id`';
		
		$db->setQuery($q);
		$order['items'] = $db->loadObjectList();
		
		$base_url = $this->getBaseUrl();
		if(!empty($order['items'])){
			foreach ($order['items'] as $item){
				//hack for bugs in virtuemart product model
				$view = JRequest::getWord('view');
				if(empty($view)){
					JRequest::setVar('view', 'vmemails');
				}
				$product = $this->getProductById($item->virtuemart_product_id);
				$item->image_thumb = $product->productThumbPath;
			}
		}
		return $order;
	}
	
	private function getOrderByOrderId_old($virtuemart_order_id){
			$orderModel = $this->getVmModels('orders');
			$order = $orderModel->getOrder($virtuemart_order_id);
			
			$last_order_history = $this->getLastOrderHistory($virtuemart_order_id);
			$order['history'] = $last_order_history;
			if(!empty($order['details'])){
				$order['virtuemart_order_id'] = $virtuemart_order_id;
				$order['order_number'] = $order['details']['BT']->order_number;
			}
			
			if(!empty($order['items'])){
				foreach ($order['items'] as $item){
					//hack for bugs in virtuemart product model
					$view = JRequest::getWord('view');
					if(empty($view)){
						JRequest::setVar('view', 'vmemails');
					}
					$product = $this->getProductById($item->virtuemart_product_id);
					$item->image_thumb = $product->productThumbPath;
					$item->categories = $product->categories;
					$item->prod_url = $product->prod_url;
				}
			}
			
			$currencyModel = $this->getVmModels('currency');
			$currency = $currencyModel->getCurrency($order['details']['BT']->user_currency_id);
			$order['currency_code_3'] = $currency->currency_code_3;
			$order['currency_name'] = $currency->currency_name;
			$order['currency_symbol'] = $currency->currency_symbol;
			
			unset($order['details']['BT']->address_type);
			unset($order['details']['BT']->address_type_name);
			unset($order['details']['BT']->company);
			unset($order['details']['BT']->title);
			unset($order['details']['BT']->middle_name);
			unset($order['details']['BT']->phone_1);
			unset($order['details']['BT']->phone_2);
			unset($order['details']['BT']->fax);
			unset($order['details']['BT']->address_1);
			unset($order['details']['BT']->address_2);
			unset($order['details']['BT']->city);
			unset($order['details']['BT']->virtuemart_state_id);
			unset($order['details']['BT']->agreed);
			unset($order['details']['BT']->created_by);
			unset($order['details']['BT']->modified_by);
			unset($order['details']['BT']->locked_on);
			unset($order['details']['BT']->locked_by);
			unset($order['details']['BT']->virtuemart_vendor_id);
			unset($order['details']['BT']->user_currency_id);
			unset($order['details']['BT']->user_currency_rate);
			unset($order['details']['BT']->virtuemart_paymentmethod_id);
			unset($order['details']['BT']->virtuemart_shipmentmethod_id);
			unset($order['details']['BT']->customer_note);
			unset($order['details']['BT']->ip_address);
		
		return $order;
	}
	
	private function getLastOrderHistory($virtuemart_order_id){
		$db = JFactory::getDBO();
		$q = "SELECT a.order_status_code, a.created_on, b.order_status_name, b.virtuemart_orderstate_id
			FROM #__virtuemart_order_histories a JOIN #__virtuemart_orderstates b 
			ON a.order_status_code=b.order_status_code 
			WHERE virtuemart_order_id=".$virtuemart_order_id."
			ORDER BY virtuemart_order_history_id DESC";
		$db->setQuery($q);
		$order_history = $db->loadAssoc();
		return $order_history;
	}
	
	function getVmModels($vmModelName){
		if(!key_exists($vmModelName, $this->vmModels)){
			$this->loadVmModel($vmModelName);
		}
		return $this->vmModels[$vmModelName];
	}
	
	private function loadVmModel($vmModelName){
		$this->vmModels[$vmModelName] = JModel::getInstance($vmModelName, 'VirtuemartModel');
	}
	
	private function getVendor(){
		if(empty($this->vendor)){
			$vendorModel = $this->getVmModels('vendor');
			$this->vendor = & $vendorModel->getVendor();
			$vendorModel->addImages($this->vendor,1);
		}
		return $this->vendor;
	}
	
	public function getCarts($limit, $page, $since_id, $updated_at_min, $updated_at_max){
		$where = '';
		$result = array();
		remarketyLogger::log('*** getCarts updated_at_min='.$updated_at_min, remarketyLogger::LEVEL_DEBUG);
		if($updated_at_min == null  || empty($updated_at_min)){
//			remarketyLogger::log('ERROR getCarts updated_at_min is empty', remarketyLogger::LEVEL_ERROR);
//			return $result;
			$allTime = new JDate('1970-01-01 00:00:00');
			$updated_at_min = $allTime->toMySQL();
		}
		$date = new DateTime($updated_at_min, new DateTimeZone('UTC'));
		$time = $date->format('U');
		
		if($updated_at_min != null){
			$updated_at_min_where = " time > '".$time."'";
			if(!empty($where)){
				$updated_at_min_where = " AND ".$updated_at_min_where;
			} 
			$where .= $updated_at_min_where;
		}
		
		if(!empty($where)){
			$where = ' WHERE '.$where;
		}
		
		$selecct = " data "; 
		$from = ' FROM #__session ';
		
		$ordering = '';

		$sessions = $this->exeQuery($selecct, $from, $where, '', $ordering, '', $page);
		$version = $this->getVmVersion();
		remarketyLogger::log('*** getCarts VmVersion: '.print_r($version, true), remarketyLogger::LEVEL_DEBUG);
		
		$isNewVersion = version_compare($version['RELEASE'], '2.0.21');
		if($isNewVersion > 0){
			remarketyLogger::log('*** getCarts VmVersion > 2.0.21', remarketyLogger::LEVEL_DEBUG);
			$isNewVersion = true;
		}else{
			$isNewVersion = false;
		}
		
		$limit_counter = 0;
		if(!empty($sessions)){
			remarketyLogger::log('*** getCarts sessions count='.count($sessions), remarketyLogger::LEVEL_DEBUG);
			$duplicate_emails = array();
			foreach ($sessions as $data){
				if($limit_counter > $limit)
					break;
					
				$data_str = $data->data;
				remarketyLogger::log($data_str, remarketyLogger::LEVEL_DEBUG);
				$dataArr = self::unserializeSession($data_str);
				
				if(!isset($dataArr['__vm']['vmcart'])){
					continue;
				}
				$cart = unserialize($dataArr['__vm']['vmcart']);
				
				remarketyLogger::log('*** getCarts cart session: '.print_r($cart, true), remarketyLogger::LEVEL_DEBUG);
				
				if(empty($cart->BT)){
					continue;
				}
				
				if($isNewVersion){
					$cart = $this->getCartData_new($cart);
				}
				else{
					$cart = $this->getCartData($cart);
				}
				
				if( empty($cart['email']) || in_array($cart['email'], $duplicate_emails)){
					continue;
				}
				
				$duplicate_emails[] = $cart['email'];
				
				//$date->setTimestamp($dataArr['__default']['session.timer.now']);
				
				$last_updated_obj = new DateTime('now', new DateTimeZone($this->real_time_zone) );
				//getdate returns array with data in local time
				$dateu = getdate( ( int )$dataArr['__default']['session.timer.now']);
				$last_updated_obj->setDate( $dateu['year'] , $dateu['mon'] , $dateu['mday'] );
				$last_updated_obj->setTime( $dateu['hours'] , $dateu['minutes'] , $dateu['seconds'] );
				//here we trnasfer it to UTC
				$last_updated_obj->setTimezone(new DateTimeZone('UTC'));
				$last_modified = $last_updated_obj->format('Y-m-d H:i:s');
						
				$cart['modifiedOn'] = $last_modified;
				
				$result[] = $cart;
				$limit_counter++;
			}
		}
		
		return $result;
	}
	
	private function getCartData($cart){
		$result = array();
		$result['email'] = $cart->BT['email'];
		$result['firstName'] = $cart->BT['first_name'];
		$result['lastName'] = $cart->BT['last_name'];
		$result['cartTotal'] = $cart->pricesUnformatted['billTotal'];
		
		$result['shipping'] = $cart->cartData['shipmentName'];
		$result['couponCode'] = $cart->couponCode;
		$result['couponDiscount'] = $cart->pricesUnformatted['salesPriceCoupon'];
		$result['otherDiscount'] = $cart->pricesUnformatted['discountAmount'];
		
		$currencyModel =  $this->getVmModels('currency');
		$currency = $currencyModel->getCurrency($cart->pricesCurrency);
		
		$result['currency'] = $currency->currency_code_3;
		$result['money_with_currency_format'] = $currency->currency_positive_style;
		$result['money_format'] = $currency->currency_positive_style;
		
		$result['currency_code_3'] = $currency->currency_code_3;
		$result['currency_name'] = $currency->currency_name;
		$result['currency_symbol'] = $currency->currency_symbol;
		
		foreach ($cart->products as $product) {
			$items_arr = array();
			$items_arr['sku'] = $product->product_sku;
			$items_arr['storeProductId'] = $product->virtuemart_product_id;
			$items_arr['productTitle'] = $product->product_name;
			$items_arr['productPrice'] = $product->product_price;
			$items_arr['quantity'] = $product->quantity;
			$items_arr['link'] = $product->link;
			
			$result['items'][] = $items_arr;
		}
		return $result;
		
	}

	private static function unserializeSession($session_data) {
		try{
			$method = ini_get("session.serialize_handler");
			$dataArr = array();
			switch ($method) {
				case "php":
					$dataArr =  self::unserialize_php($session_data);
					break;
				case "php_binary":
					$dataArr = self::unserialize_phpbinary($session_data);
					break;
				default:
//					emp_logger::log('helper::unserializeSession: ', emp_logger::LEVEL_DEBUG, "Unsupported session.serialize_handler: " . $method . ". Supported: php, php_binary");
					$dataArr = false;
			}
			return $dataArr;
		}
		catch (Exception $e){
			remarketyLogger::log('unserializeSession data= '.$session_data. " \nException: ".$e->getMessage(), remarketyLogger::LEVEL_DEBUG);
			return false;
		}
	}

	private static function unserialize_php($session_data) {
		$return_data = array();
		$offset = 0;
		while ($offset < strlen($session_data)) {
			if (!strstr(substr($session_data, $offset), "|")) {
				throw new Exception("invalid data, remaining: " . substr($session_data, $offset));
			}
			$pos = strpos($session_data, "|", $offset);
			$num = $pos - $offset;
			$varname = substr($session_data, $offset, $num);
			$offset += $num + 1;
			$data = unserialize(substr($session_data, $offset));
			$return_data[$varname] = $data;
			$offset += strlen(serialize($data));
		}
		return $return_data;
	}

	private static function unserialize_phpbinary($session_data) {
		$return_data = array();
		$offset = 0;
		while ($offset < strlen($session_data)) {
			$num = ord($session_data[$offset]);
			$offset += 1;
			$varname = substr($session_data, $offset, $num);
			$offset += $num;
			$data = unserialize(substr($session_data, $offset));
			$return_data[$varname] = $data;
			$offset += strlen(serialize($data));
		}
		return $return_data;
	}
	
	function createCoupon($coupon_code, $percent_or_total, $gift_or_permanent, $value, $start_date, $expire_date, $validFromValue){
		remarketyLogger::log('createCoupon coupon_code='.$coupon_code, remarketyLogger::LEVEL_DEBUG);
		if($percent_or_total == 'awo' && $this->isAwoInstalled()){
			$templateID = $value;
			$this->createDynamicCouponAWO($coupon_code, $templateID, $expire_date);
		}else{
			$coupon = array(
				'coupon_code' =>  $coupon_code,
		        'percent_or_total' => strtolower($percent_or_total), 
		        'gift_or_permanent' => strtolower($gift_or_permanent),
		        'coupon_value' => (float)$value,
				'validFromValue' => isset($validFromValue) && !is_null($validFromValue) ? (float)$validFromValue : 0,
				'start_date' => isset($start_date) && !is_null($start_date) ? $start_date : '',
				'expire_date' => isset($expire_date) && !is_null($expire_date) ? $expire_date : ''
			);
		}

		$isDeleteExpiredCoupons = self::getParamByName('isDeleteExpiredCoupons', false);
		if(!empty($isDeleteExpiredCoupons)){
			$this->deleteExpiredCoupons();
		}
		
		if($this->add_coupon_code($coupon))
			return true;
		
		return false;
	}
	
	function deleteExpiredCoupons(){
		remarketyLogger::log('deleteExpiredCoupons() start', remarketyLogger::LEVEL_DEBUG);
		$db = JFactory::getDbo();
		$q = 'DELETE FROM `#__virtuemart_coupons` WHERE coupon_expiry_date < NOW() AND coupon_expiry_date != "0000-00-00 00:00:00"';
		$db->setQuery($q);
		$res = $db->query();
		remarketyLogger::log('deleteExpiredCoupons() end', remarketyLogger::LEVEL_DEBUG);
	}
    
	function add_coupon_code( &$d ) {
	    $bRes = false;
		$coupon_code = $d['coupon_code'];
		$percent_or_total = strtolower($d['percent_or_total']) == 'percent' ? 'percent' : 'total';
		$gift_or_permanent = strtolower($d['gift_or_permanent']) == 'gift' ? 'gift' : 'permanent';
		$coupon_value = (float)$d['coupon_value'];
		$validFromValue = (float)$d['validFromValue'];
		$start_date = $d['start_date'];
		$expire_date = $d['expire_date'];
	
		$fields = array(
						'coupon_code' => $coupon_code,
						'percent_or_total' => $percent_or_total,
						'coupon_type' => $gift_or_permanent,
						'coupon_value' => $coupon_value,
						'coupon_start_date' => $start_date,
						'coupon_expiry_date' => $expire_date,
						'coupon_value_valid' => $validFromValue
					);

		$model = $this->getVmModels('coupon');
		$couponId = $model->store($fields);
		if(!empty($couponId)){
			$bRes = true;
		}
		
		return $bRes;
    }
    
	private function createDynamicCouponAWO($coupon_code, $templateID, $expiryDate, &$debugInfo){
			if(empty($coupon_code)){
				remarketyLogger::log( "Coupon code is empty. Dynamic AWO Coupon was not created. Coupon code: ".$coupon_code, remarketyLogger::LEVEL_DEBUG);
				return false;
			}
			
			if(!is_numeric($templateID)){
				remarketyLogger::log( "Template ID format is not numeric. Coupon code: ".$coupon_code, remarketyLogger::LEVEL_DEBUG);
				return false;
			}
			
			if(empty($expiryDate) || !is_numeric($expiryDate) ){
				$expiryDate = null;
			}
			
			$list = awoAutoGenerate::getCouponTemplates();
			$isIdExists = false;
			if(!is_array($list)){
				remarketyLogger::log( "AwoCoupon template ID was not found: ".$templateID." Coupon code: ".$coupon_code, remarketyLogger::LEVEL_DEBUG);
				return false;
			}else{
				foreach ($list as $arr) {
					if($arr->id == $templateID){
						$isIdExists = true;
						break;
					}
					
				}
				if(!$isIdExists){
					remarketyLogger::log( "AwoCoupon template ID was not found: ".$templateID." Coupon code: ".$coupon_code, remarketyLogger::LEVEL_DEBUG);
					return false;
				}
			}
			
			$obj = awoAutoGenerate::generateCoupon($templateID, $coupon_code, $expiryDate);
			if($obj === false){
				$debugInfo[] = "AwoCoupon was not able to generate coupon from this template ID: ".$templateID;
				return false;
			}

			return true;
	}
	
	private function isAwoInstalled()
	{
		$success = false;
		
	    jimport('joomla.filesystem.file');
        if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_awocoupon'.DS.'helpers'.DS.'plgautogenerate.php')) 
        {
			include_once JPATH_ADMINISTRATOR.DS.'components'.DS.'com_awocoupon'.DS.'helpers'.DS.'plgautogenerate.php' ;
            $success = true;
        }
		return $success;
	}

    public function getShopStatuses(){
    	$db = JFactory::getDbo();
		$q = 'SELECT `order_status_name`,`order_status_code` FROM `#__virtuemart_orderstates` order by `ordering` ';
		$db->setQuery($q);
		$statuses = $this->_db->loadAssocList('order_status_code');
		foreach ($statuses as $idx => $status){
			$statuses[$idx]['order_status_name'] = JText::_($statuses[$idx]['order_status_name']);
		}
		
		return $statuses;
    }
    
    public function getCartData_new($sessionCart){
    	$remarketyCart = new remarketyCart();
    	$remarketyCart->products = $sessionCart->products;
    	$remarketyCart->vendorId	 							= $sessionCart->vendorId;
    	$remarketyCart->lastVisitedCategoryId	 			= $sessionCart->lastVisitedCategoryId;
    	$remarketyCart->virtuemart_shipmentmethod_id	= $sessionCart->virtuemart_shipmentmethod_id;
    	$remarketyCart->virtuemart_paymentmethod_id 	= $sessionCart->virtuemart_paymentmethod_id;
    	$remarketyCart->automaticSelectedShipment 		= $sessionCart->automaticSelectedShipment;
    	$remarketyCart->automaticSelectedPayment 		= $sessionCart->automaticSelectedPayment;
    	$remarketyCart->BT 										= $sessionCart->BT;
    	$remarketyCart->ST 										= $sessionCart->ST;
    	$remarketyCart->tosAccepted 							= $sessionCart->tosAccepted;
    	$remarketyCart->customer_comment 					= base64_decode($sessionCart->customer_comment);
    	$remarketyCart->couponCode 							= $sessionCart->couponCode;
    	$remarketyCart->cartData 								= $sessionCart->cartData;
    	$remarketyCart->order_number							= $sessionCart->order_number;
    	$remarketyCart->lists 									= $sessionCart->lists;
    	
    	//$remarketyCart->pricesUnformatted					= $sessionCart->pricesUnformatted;
    	$remarketyCart->pricesCurrency						= $sessionCart->pricesCurrency;
    	$remarketyCart->paymentCurrency						= $sessionCart->paymentCurrency;
    	
    	$remarketyCart->_inCheckOut 							= $sessionCart->_inCheckOut;
    	$remarketyCart->_dataValidated						= $sessionCart->_dataValidated;
    	$remarketyCart->_confirmDone							= $sessionCart->_confirmDone;
    	$remarketyCart->STsameAsBT							= $sessionCart->STsameAsBT;
    	$remarketyCart->getCartPrices();
    	
    	$result = array();
    	$result['email'] = isset($remarketyCart->BT['email']) ? $remarketyCart->BT['email'] : null;
    	$result['firstName'] = isset($remarketyCart->BT['first_name']) ? $remarketyCart->BT['first_name'] : "";
    	$result['lastName'] = isset($remarketyCart->BT['last_name']) ? $remarketyCart->BT['last_name'] : "";
    	$result['cartTotal'] = $remarketyCart->pricesUnformatted['billTotal'];
    	
    	$result['shipping'] = $remarketyCart->pricesUnformatted['shipmentValue'];
    	$result['couponCode'] = $remarketyCart->couponCode;
    	$result['couponDiscount'] = $remarketyCart->pricesUnformatted['salesPriceCoupon'];
    	$result['otherDiscount'] = $remarketyCart->pricesUnformatted['discountAmount'];
    	
    	$currencyModel =  $this->getVmModels('currency');
    	$currency = $currencyModel->getCurrency($remarketyCart->pricesCurrency);
    	
    	$result['currency'] = $currency->currency_code_3;
    	$result['money_with_currency_format'] = $currency->currency_positive_style;
    	$result['money_format'] = $currency->currency_positive_style;
    	
    	$result['currency_code_3'] = $currency->currency_code_3;
    	$result['currency_name'] = $currency->currency_name;
    	$result['currency_symbol'] = $currency->currency_symbol;
    	
    	foreach ($remarketyCart->products as $product) {
    		$items_arr = array();
    		$items_arr['sku'] = $product->product_sku;
    		$items_arr['storeProductId'] = $product->virtuemart_product_id;
    		$items_arr['productTitle'] = $product->product_name;
    		$items_arr['productPrice'] = $product->product_price;
    		$items_arr['quantity'] = $product->quantity;
    		$items_arr['link'] = $product->link;
    	
    		$result['items'][] = $items_arr;
    	}
    	
    	return $result;
    }
    
    private function getVmVersion(){
    	require_once (JPATH_ADMINISTRATOR.DS."components".DS."com_virtuemart".DS."version.php");
    	$versionArr['PRODUCT'] = vmVersion::$PRODUCT;
    	$versionArr['RELEASE'] = vmVersion::$RELEASE;
    	$versionArr['DEV_STATUS'] = vmVersion::$DEV_STATUS;
    	$versionArr['CODENAME'] = vmVersion::$CODENAME;
    	$versionArr['RELDATE'] = vmVersion::$RELDATE;
    	$versionArr['RELTIME'] = vmVersion::$RELTIME;
    	$versionArr['RELTZ'] = vmVersion::$RELTZ;
    	$versionArr['REVISION'] = vmVersion::$REVISION;
    	return $versionArr;
    }
    
	static function getParamByName($name, $default = ''){
		$compParams = JComponentHelper::getParams('com_remarkety');
		if($compParams->get('params') == null){
			return $default;
		}
		$value = $compParams->get('params')->$name;
		return $value;
	}
	
	private function getBaseUrl(){
		if($this->base_url == null){
			$this->base_url = $this->getVendor()->vendor_url;
			if(!$this->endsWith($this->base_url, '/')){
				$this->base_url .= '/' ;
			}
		}
		if (substr($this->base_url,0,4) != 'http'){
			$this->base_url = "http://".ltrim($this->base_url,'/');
		}
		return $this->base_url;
	}
	
	private function getShooperGroups($userId){
		$db = JFactory::getDBO();
		$q = "SELECT DISTINCT ug.virtuemart_shoppergroup_id, g.shopper_group_name FROM #__virtuemart_vmuser_shoppergroups ug INNER JOIN #__virtuemart_shoppergroups g ON ug.virtuemart_shoppergroup_id = g.virtuemart_shoppergroup_id where ug.virtuemart_user_id =".$userId;
		$db->setQuery($q);
		$result = $db->loadObjectList();
		return $result;
	}
	
	function endsWith($haystack, $needle)
	{
	    return $needle === "" || substr($haystack, -strlen($needle)) === $needle;
	}
}

if (!class_exists('VirtueMartCart'))
	require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
if(!class_exists('remarketyCalculation')) require(JPATH_VM_ADMINISTRATOR.DS.'helpers'.DS.'calculationh.php');
class remarketyCart extends VirtueMartCart{
	public function __construct(){
	}
	
	public function getCartPrices($checkAutomaticSelected=true ) {
	
		$remarketyCalculator = remarketyCalculation::getInstance();

		$this->pricesUnformatted = $remarketyCalculator->getCheckoutPrices($this, $checkAutomaticSelected);
	
		return $this->pricesUnformatted;
	}
}

class remarketyCalculation extends calculationHelper {
	
	public function __construct() {
		$this->_db = JFactory::getDBO();
		$this->_app = JFactory::getApplication();
	
		//We store in UTC and use here of course also UTC
		$jnow = JFactory::getDate();
		$this->_now = $jnow->toMySQL();
		$this->_nullDate = $this->_db->getNullDate();
	
		//Attention, this is set to the mainvendor atm.
		//This means also that atm for multivendor, every vendor must use the shopcurrency as default
		//         $this->vendorCurrency = 1;
		$this->productVendorId = 1;
	
		if (!class_exists('CurrencyDisplay')
		)require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'currencydisplay.php');
		$currencyDisplay = new CurrencyDisplay();
		$this->_currencyDisplay = $currencyDisplay->getInstance();
		$this->_debug = false;
	
		if(!empty($this->_currencyDisplay->_vendorCurrency)){
			$this->vendorCurrency = $this->_currencyDisplay->_vendorCurrency;
			$this->vendorCurrency_code_3 = $this->_currencyDisplay->_vendorCurrency_code_3;
			$this->vendorCurrency_numeric = $this->_currencyDisplay->_vendorCurrency_numeric;
		}
		/*	else if(VmConfig::get('multix','none')!='none'){
		 $this->_db->setQuery('SELECT `vendor_currency` FROM #__virtuemart_vendors  WHERE `virtuemart_vendor_id`="1" ');
		 $single = $this->_db->loadResult();
		 $this->vendorCurrency = $single;
			}*/
	
		$this->setShopperGroupIds();
	
		$this->setVendorId($this->productVendorId);
	
		$this->rules['Marge'] = array();
		$this->rules['Tax'] 	= array();
		$this->rules['VatTax'] 	= array();
		$this->rules['DBTax'] = array();
		$this->rules['DATax'] = array();
	
		//round only with internal digits
		$this->_roundindig = VmConfig::get('roundindig',FALSE);
	}
	
	static public function getInstance() {
		self::$_instance = new remarketyCalculation ();
		return self::$_instance;
	}
}
?>
